const path = require('path')

const {
  promisify
} = require('util')
const download = promisify(require('download-git-repo'))

const {
  vuePo
} = require('../config/respo-config')

const {
  commandSpawn
} = require('../util/terminal')

const {
  complie,
  writeToFile
} = require('../util/utils')

const createProjectAction = async (project) => {
  console.log('helps you create a empty project~');
  // 1. clone项目
  await download(vuePo, project, {
    clone: true
  })

  // 2. 执行 npm install
  await commandSpawn('cnpm', ['install'], {
    cwd: `./${project}`
  })

  // 3. 执行 npm run serve 启动项目
  await commandSpawn('cnpm', ['run', 'serve'], {
    cwd: `./${project}`
  })
}

const addComponentAction = async (name, dest) => {
  console.log('我是name', name);
  // 1. 编译ejs 模版
  const result = await complie('vue-component.ejs', {name: name, lowerName: name.toLowerCase()})

  // 2.写文件
  const destPath = path.resolve(dest, `${name}.vue`)
  console.log(destPath);
  writeToFile(destPath, result)
}

module.exports = {
  createProjectAction,
  addComponentAction
}